import numpy as np

from psyneulink.core.components.functions.combinationfunctions import PredictionErrorDeltaFunction

np.set_printoptions(suppress=True)


def test_prediction_error_delta_first_run():
    learning_rate = 0.3

    stimulus_onset = 41
    sample = np.zeros(60)
    sample[stimulus_onset:] = 1

    reward_onset = 54
    target = np.zeros(60)
    target[reward_onset] = 1

    delta_function = PredictionErrorDeltaFunction()
    delta_vals = np.zeros((60, 60))

    weights = np.zeros(60)
    for t in range(60):
        print("Timestep {}".format(t))
        new_sample = sample * weights
        # print("sample = {}".format(new_sample))
        delta_vals[t] = delta_function(variable=[new_sample, target])
        print("delta: {}".format(delta_vals[t]))

        for i in range(59):
            weights[i] = weights[i] + learning_rate * sample[i] * \
                         delta_vals[t][i + 1]

    validation_array = np.array([[0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  1.0, 0.0, 0.0, 0.0, 0.0, 0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.3,
                                  0.7, 0.0, 0.0, 0.0, 0.0, 0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.09,
                                  0.42000000000000004, 0.49, 0.0, 0.0, 0.0, 0.0,
                                  0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.027, 0.189,
                                  0.44100000000000006, 0.34299999999999997, 0.0,
                                  0.0, 0.0, 0.0, 0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0081, 0.0756,
                                  0.2646, 0.4116, 0.24009999999999998, 0.0, 0.0,
                                  0.0, 0.0, 0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.00243, 0.02835, 0.1323,
                                  0.3087, 0.3601500000000001,
                                  0.16806999999999994, 0.0, 0.0, 0.0, 0.0, 0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0007289999999999999,
                                  0.010206, 0.05953499999999999, 0.18522,
                                  0.32413500000000006, 0.30252599999999996,
                                  0.117649, 0.0, 0.0, 0.0, 0.0, 0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.00021869999999999998, 0.0035721,
                                  0.025004699999999998, 0.09724049999999998,
                                  0.2268945, 0.31765230000000005,
                                  0.24706289999999997, 0.08235429999999999, 0.0,
                                  0.0, 0.0, 0.0, 0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 6.560999999999999e-05,
                                  0.0012247199999999999, 0.01000188, 0.04667544,
                                  0.1361367, 0.25412184, 0.29647548,
                                  0.19765032000000005, 0.05764800999999997, 0.0,
                                  0.0, 0.0, 0.0, 0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  1.9682999999999998e-05, 0.000413343,
                                  0.003857868, 0.021003947999999998,
                                  0.073513818, 0.171532242, 0.26682793199999993,
                                  0.2668279320000001, 0.15564962699999996,
                                  0.040353607000000014, 0.0, 0.0, 0.0, 0.0,
                                  0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  5.904899999999999e-06, 0.000137781,
                                  0.0014467005, 0.009001692,
                                  0.036756909000000004, 0.1029193452,
                                  0.200120949, 0.26682793199999993,
                                  0.2334744405000001, 0.12106082099999993,
                                  0.028247524900000043, 0.0, 0.0, 0.0, 0.0,
                                  0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  1.7714699999999997e-06,
                                  4.5467729999999994e-05, 0.00053045685,
                                  0.0037131979500000002, 0.0173282571,
                                  0.05660563986, 0.13207982633999998,
                                  0.2201330439, 0.25682188454999993,
                                  0.19975035465000013, 0.09321683216999987,
                                  0.019773267430000074, 0.0, 0.0, 0.0, 0.0,
                                  0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  5.314409999999999e-07, 1.4880347999999997e-05,
                                  0.00019096446599999996, 0.00148527918,
                                  0.0077977156950000005, 0.029111471928000003,
                                  0.07924789580399999, 0.15849579160799998,
                                  0.23113969609499996, 0.23970042558000004,
                                  0.16779029790600009, 0.07118376274799987,
                                  0.013841287201000085, 0.0, 0.0, 0.0, 0.0,
                                  0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0,
                                  1.5943229999999994e-07, 4.8361131e-06,
                                  6.770558339999998e-05, 0.0005792588802,
                                  0.0033790101345, 0.014191842564900003,
                                  0.044152399090799994, 0.1030222645452,
                                  0.18028896295409996, 0.23370791494049992,
                                  0.21812738727780012, 0.1388083373586,
                                  0.05398102008389993, 0.009688901040700082,
                                  0.0, 0.0, 0.0, 0.0, 0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 1.61026623e-06,
                                  2.3696954189999994e-05, 0.00022117157244,
                                  0.00141918425649, 0.006622859863620001,
                                  0.023180009522670002, 0.06181335872711999,
                                  0.12620227406787, 0.19631464855001995,
                                  0.22903375664168996, 0.19433167230204007,
                                  0.11336014217619006, 0.040693384370939945,
                                  0.006782230728490046, 0.0, 0.0, 0.0, 0.0,
                                  0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0,
                                  8.719352486999997e-06, 8.2939339665e-05,
                                  0.000580575377655, 0.002980286938629,
                                  0.011590004761335003, 0.034770014284004995,
                                  0.08113003332934499, 0.14723598641251498,
                                  0.20613038097752096, 0.218623131339795,
                                  0.1700402132642851, 0.09156011483461501,
                                  0.03052003827820493, 0.0047475615099430435,
                                  0.0, 0.0, 0.0, 0.0, 0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0,
                                  3.3601154386499996e-05,
                                  0.00023223015106199995, 0.0013004888459472001,
                                  0.0055632022854408, 0.018544007618136,
                                  0.048678019997607, 0.100961819254296,
                                  0.16490430478201676, 0.20987820608620322,
                                  0.20404825591714193, 0.1464961837353841,
                                  0.07324809186769199, 0.02278829524772641,
                                  0.0033232930569601082, 0.0, 0.0, 0.0, 0.0,
                                  0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.00010327019970509998, 0.0005527077595275599,
                                  0.0025793028777952804, 0.00945744388524936,
                                  0.0275842113319773, 0.0643631597746137,
                                  0.12014456491261222, 0.17839647517327273,
                                  0.2081292210354848, 0.18678263426261454,
                                  0.12452175617507655, 0.05811015288170229,
                                  0.016948794590496474, 0.002326305139872087,
                                  0.0, 0.0, 0.0, 0.0, 0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.00026908252756336796, 0.0011606862950078762,
                                  0.004642745180031503, 0.014895474119267742,
                                  0.038617895864768215, 0.08109758131601326,
                                  0.13762013799081035, 0.18731629893193635,
                                  0.2017252450036237, 0.1681043708363532,
                                  0.10459827518706422, 0.045761745394340525,
                                  0.012562047755309225, 0.0016284135979104386,
                                  0.0, 0.0, 0.0, 0.0, 0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0006172884160657308, 0.002205303960514964,
                                  0.007718563861802375, 0.022012200642917885,
                                  0.05136180150014173, 0.09805434831845238,
                                  0.15252898627314818, 0.1916389827534426,
                                  0.1916389827534425, 0.1490525421415665,
                                  0.08694731624924712, 0.03580183610263121,
                                  0.009281957508089578, 0.0011398895185372737,
                                  0.0, 0.0, 0.0, 0.0, 0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.00127887960422022,
                                  0.0038592819309011877, 0.012006654896137028,
                                  0.030817080900085034, 0.06536956554563493,
                                  0.11439673970486111, 0.1642619852172365,
                                  0.1916389827534426, 0.1788630505698796,
                                  0.13042097437387068, 0.07160367220526243,
                                  0.027845872524268733, 0.006839337111223864,
                                  0.0007979226629760694, 0.0, 0.0, 0.0, 0.0,
                                  0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0024366641834905763, 0.006303493820471939,
                                  0.01764978269732143, 0.04118282629375,
                                  0.08007771779340278, 0.12935631335857373,
                                  0.17247508447809834, 0.1878062030983737,
                                  0.16433042771107698, 0.11277578372328811,
                                  0.058476332300964384, 0.021543911900355206,
                                  0.005026912776749604, 0.0005585458640832153,
                                  0.0, 0.0, 0.0, 0.0, 0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0043277123296321576, 0.009707380483526788,
                                  0.024709695776250002, 0.05285129374364584,
                                  0.09486129646295406, 0.1422919446944311,
                                  0.17707442006418095, 0.18076347048218466,
                                  0.1488640345147404, 0.09648594829659096,
                                  0.047396606180781564, 0.01658881216327357,
                                  0.0036864027029497315, 0.0003909821048582174,
                                  0.0, 0.0, 0.0, 0.0, 0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.007239926474690194,
                                  0.014208075071343751, 0.03315217516646875,
                                  0.06545429455943831, 0.10909049093239716,
                                  0.15272668730535605, 0.17818113518958212,
                                  0.17119363969195134, 0.13315060864929562,
                                  0.08175914566184805, 0.03815426797552923,
                                  0.012718089325176374, 0.0026977765235223217,
                                  0.00027368747340072996, 0.0, 0.0, 0.0, 0.0,
                                  0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.011502348996093318,
                                  0.01989130509988125, 0.04284281098435962,
                                  0.07854515347132598, 0.1221813498442848,
                                  0.16036302167062388, 0.17608488654029292,
                                  0.15978073037915452, 0.11773316975306136,
                                  0.0686776823559524, 0.030523414380423386,
                                  0.009711995484680158, 0.0019705498084858775,
                                  0.00019158123138052208, 0.0, 0.0, 0.0, 0.0,
                                  0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.017469740526057695,
                                  0.02677675686522476, 0.053553513730449524,
                                  0.09163601238321362, 0.13363585139218653,
                                  0.1650795811315246, 0.17119363969195145,
                                  0.14716646219132656, 0.10301652353392865,
                                  0.05723140196329368, 0.02427998871170045,
                                  0.0073895617818218184, 0.0014368592353543042,
                                  0.00013410686196635435, 0.0, 0.0, 0.0, 0.0,
                                  0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.02550276758562512,
                                  0.03480978392479219, 0.06497826332627876,
                                  0.10423596408590546, 0.14306897031398796,
                                  0.16691379869965267, 0.16398548644176403,
                                  0.13392148059410713, 0.08928098706273813,
                                  0.0473459779878157, 0.01921286063273686,
                                  0.005603751017881575, 0.0010460335233379858,
                                  9.387480337641474e-05, 0.0, 0.0, 0.0, 0.0,
                                  0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.035945702763062776,
                                  0.04386032774523817, 0.07675557355416678,
                                  0.1158858659543302, 0.1502224188296874,
                                  0.16603530502228608, 0.15496628468746698,
                                  0.12052933253469633, 0.07670048434026144,
                                  0.03890604278129206, 0.015130127748280264,
                                  0.004236435769518487, 0.0007603859073495034,
                                  6.571236236352362e-05, 0.0, 0.0, 0.0, 0.0,
                                  0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.04910380108663422,
                                  0.05372890148791675, 0.0884946612742158,
                                  0.12618683181693738, 0.15496628468746698,
                                  0.16271459892184037, 0.1446351990416358,
                                  0.10738067807636587, 0.06536215187257055,
                                  0.0317732682713886, 0.011862020154651653,
                                  0.0031936208108678255, 0.0005519838438536873,
                                  4.5998653654510946e-05, 0.0, 0.0, 0.0, 0.0,
                                  0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.06522247153300925,
                                  0.06415862942380646, 0.09980231243703228,
                                  0.13482066767809628, 0.157290778957779,
                                  0.157290778957779, 0.13345884275205488,
                                  0.09477512021522716, 0.05528548679221601,
                                  0.025799893836367493, 0.009261500351516516,
                                  0.002401129720763562, 0.000400188286794001,
                                  3.219905755813546e-05, 0.0, 0.0, 0.0, 0.0,
                                  0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.08447006036015119,
                                  0.07485173432777421, 0.1103078190093515,
                                  0.14156170106200106, 0.157290778957779,
                                  0.15014119809606175, 0.12185372599100663,
                                  0.08292823018832374, 0.04643980890546151,
                                  0.02083837579091219, 0.007203389162290574,
                                  0.0018008472905727269, 0.0002897915180232191,
                                  2.2539340290728127e-05, 0.0, 0.0, 0.0, 0.0,
                                  0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.10692558065848345,
                                  0.0854885597322474, 0.11968398362514637,
                                  0.1462804244307344, 0.15514590469926381,
                                  0.14165495646454518, 0.11017607725020184,
                                  0.07198170380346502, 0.038759378971096714,
                                  0.016747879802325727, 0.005582626600775242,
                                  0.0013475305588078745, 0.00020961586470347182,
                                  1.5777538203476382e-05, 0.0, 0.0, 0.0, 0.0,
                                  0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.13257214857815766,
                                  0.0957471869001171, 0.12766291586682277,
                                  0.14894006851129327, 0.15109862022884823,
                                  0.13221129270024212, 0.09871776521618081,
                                  0.062015006353754565, 0.032155929220465396,
                                  0.013398303841860582, 0.0043120977881849765,
                                  0.0010061561505766425, 0.00015146436675339547,
                                  1.1044276742477876e-05, 0.0, 0.0, 0.0, 0.0,
                                  0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.16129630464819278,
                                  0.10532190559012883, 0.13404606166016392,
                                  0.14958763402655972, 0.1454324219702664,
                                  0.12216323445502375, 0.08770693755745296,
                                  0.05305728321376779, 0.02652864160688395,
                                  0.0106724420257579, 0.003320315296902465,
                                  0.0007497486154296462, 0.0001093383397501313,
                                  7.730993719756718e-06, 0.0, 0.0, 0.0, 0.0,
                                  0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.19289287632523142,
                                  0.11393915241113936, 0.13870853337008265,
                                  0.1483410704096717, 0.13845166571569367,
                                  0.11182634538575253, 0.07731204125434732,
                                  0.045098690731702695, 0.021771781732546125,
                                  0.008466804007101203, 0.0025491452924606417,
                                  0.0005576255327258695, 7.885613594094121e-05,
                                  5.411695603863009e-06, 0.0, 0.0, 0.0, 0.0,
                                  0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.22707462204857323,
                                  0.12136996669882236, 0.14159829448195937,
                                  0.14537424900147833, 0.1304640696167113,
                                  0.10147205414633098, 0.06764803609755388,
                                  0.038100618031955746, 0.017780288414912637,
                                  0.00669150639270899, 0.0019516893645402655,
                                  0.0004139947136904132, 5.682280383978444e-05,
                                  3.7881869227041065e-06, 0.0, 0.0, 0.0, 0.0,
                                  0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.26348561205821996,
                                  0.12743846503376344, 0.14273108083781505,
                                  0.14090119518604827, 0.12176646497559718,
                                  0.09132484873169788, 0.058783810677874415,
                                  0.03200451914684277, 0.014453653808251588,
                                  0.005269561284258373, 0.001490380969285332,
                                  0.00030684314073514685, 4.091241876469365e-05,
                                  2.6517308459039768e-06, 0.0, 0.0, 0.0, 0.0,
                                  0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.301717151568349,
                                  0.1320262497749789, 0.14218211514228507,
                                  0.13516077612291288, 0.11263398010242742,
                                  0.08156253731555085, 0.05075002321856492,
                                  0.026739259545265348, 0.011698426051053645,
                                  0.004135807189766472, 0.001135319620720332,
                                  0.00022706392414395538,
                                  2.9434212389101155e-05, 1.856211592099477e-06,
                                  0.0, 0.0, 0.0, 0.0, 0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.3413250265008427,
                                  0.13507300938517075, 0.14007571343647335,
                                  0.12840273731676732, 0.10331254726636441,
                                  0.07231878308645512, 0.04354679411657503,
                                  0.02222700949700185, 0.009429640392667471,
                                  0.0032356609190525853, 0.0008628429117474301,
                                  0.000167775010617488, 2.116081215008947e-05,
                                  1.2993481144363273e-06, 0.0, 0.0, 0.0, 0.0,
                                  0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.3818469293163939,
                                  0.1365738206005615, 0.13657382060056156,
                                  0.12087568030164642, 0.09401441801239163,
                                  0.06368718639549109, 0.03715085873070312,
                                  0.018387798765701513, 0.00757144655058295,
                                  0.0025238155168610943, 0.0006543225414084031,
                                  0.00012379075107726845,
                                  1.5202372939393527e-05, 9.09543680149838e-07,
                                  0.0, 0.0, 0.0, 0.0, 0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.4228190754965624,
                                  0.13657382060056145, 0.13186437851088706,
                                  0.11281730161487002, 0.08491624852732138,
                                  0.05572628809605473, 0.031521940741202625,
                                  0.01514289310116601, 0.006057157240466293,
                                  0.0019629676242253202, 0.0004951630043090738,
                                  9.121423763591707e-05, 1.0914524161576011e-05,
                                  6.366805761492955e-07, 0.0, 0.0, 0.0, 0.0,
                                  0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.4637912216767308,
                                  0.13516098797365916, 0.12615025544208192,
                                  0.10444698568860544, 0.07615926039794141,
                                  0.04846498388959908, 0.026608226449191696,
                                  0.012417172342956029, 0.0048289003555940235,
                                  0.0015226262382503908, 0.0003739783743071934,
                                  6.712432359357035e-05, 7.831171085936894e-06,
                                  4.4567640333781355e-07, 0.0, 0.0, 0.0, 0.0,
                                  0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.5043395180688286,
                                  0.13245776821418598, 0.11963927451603895,
                                  0.09596066810140624, 0.06785097744543866,
                                  0.04190795665747693, 0.02235091021732094,
                                  0.010140690746747505, 0.003837018120390834,
                                  0.0011780318790675093, 0.00028192215909306206,
                                  4.933637784132472e-05, 5.6155226810794545e-06,
                                  3.119734823808784e-07, 0.0, 0.0, 0.0, 0.0,
                                  0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.5440768485330844,
                                  0.12861222010474194, 0.11253569259164908,
                                  0.087527760904616, 0.06006807120905011,
                                  0.03604084272543018, 0.0186878443761489,
                                  0.008249588958840537, 0.0030393222479937476,
                                  0.0009091989630751751, 0.00021214642471756306,
                                  3.6220121293228935e-05, 4.024457921469882e-06,
                                  2.183814377110238e-07, 0.0, 0.0, 0.0, 0.0,
                                  0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.582660514564507,
                                  0.12378926185081407, 0.1050333130855392,
                                  0.07928985399594612, 0.05285990266396423,
                                  0.030834943220645727, 0.015556367750956368,
                                  0.006686508945586533, 0.0024002852625182314,
                                  0.0007000832015678915, 0.00015936853369025172,
                                  2.6561422281634606e-05,
                                  2.8826349763866332e-06,
                                  1.5286700638661443e-07, 0.0, 0.0, 0.0, 0.0,
                                  0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.6197972931197512,
                                  0.11816247722123163, 0.09731027535866121,
                                  0.0713608685963516, 0.04625241483096865,
                                  0.02625137057973892, 0.012895410109345473,
                                  0.005400641840666021, 0.0018902246442331627,
                                  0.0005378688012045441, 0.00011952640026768879,
                                  1.9457786090026907e-05,
                                  2.0637045854421388e-06,
                                  1.0700690444842564e-07, 0.0, 0.0, 0.0, 0.0,
                                  0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.6552460362861207,
                                  0.1119068166624605, 0.08952545332996831,
                                  0.0638283324667368, 0.04025210155559966,
                                  0.02224458243862093, 0.010646979628741615,
                                  0.004347516681736163, 0.0014845178913245327,
                                  0.000412366080923543, 8.950581601441243e-05,
                                  1.4239561638595966e-05,
                                  1.4766952811662293e-06, 7.490483311389795e-08,
                                  0.0, 0.0, 0.0, 0.0, 0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.6888180812848588,
                                  0.10519240766271287, 0.0818163170709989,
                                  0.05675546319339564, 0.03484984582050599,
                                  0.018765301595657147, 0.008757140744639957,
                                  0.003488617044612674, 0.0011628723482043357,
                                  0.0003155080014507483, 6.69259397017008e-05,
                                  1.0410701731355942e-05,
                                  1.0561581467172232e-06,
                                  5.2433383190830796e-08, 0.0, 0.0, 0.0, 0.0,
                                  0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.7203758035836726,
                                  0.0981795804851987, 0.07429806090771796,
                                  0.05018377798152873, 0.030024482553051346,
                                  0.01576285334035199, 0.007176583634631806,
                                  0.0027908936356900726, 0.0009086630441783594,
                                  0.00024093338292596744, 4.997136831064175e-05,
                                  7.604338655986531e-06, 7.550407176148966e-07,
                                  3.670336823358156e-08, 0.0, 0.0, 0.0, 0.0,
                                  0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.7498296777292321,
                                  0.09101512461195449, 0.06706377602986124,
                                  0.04413598935298546, 0.025745993789241584,
                                  0.013186972428635979, 0.005860876634949275,
                                  0.002226224458236503, 0.0007083441458026751,
                                  0.00018364477854138084, 3.726125941427849e-05,
                                  5.549549274452836e-06, 5.395395127338887e-07,
                                  2.569235779681378e-08, 0.0, 0.0, 0.0, 0.0,
                                  0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.7771342151128184,
                                  0.08382972003732658, 0.06018544002679849,
                                  0.03861899068386232, 0.02197828738105989,
                                  0.010989143690529946, 0.004770480981935443,
                                  0.0017708603645063548, 0.0005509343356242535,
                                  0.00013972972280329454,
                                  2.7747746372375204e-05, 4.046546345892743e-06,
                                  3.853853662860729e-07, 1.7984650435565186e-08,
                                  0.0, 0.0, 0.0, 0.0, 0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.8022831311240164,
                                  0.07673643603416813, 0.05371550522391766,
                                  0.033626779693021636, 0.018681544273900896,
                                  0.009123544877951528, 0.0038705947967068166,
                                  0.0014048825558417022, 0.00042757295177797694,
                                  0.00010613512987400764,
                                  2.0637386364374954e-05,
                                  2.9481980520218443e-06,
                                  2.7516515155312504e-07, 1.258925530489563e-08,
                                  0.0, 0.0, 0.0, 0.0, 0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.8253040619342669,
                                  0.06983015679109295, 0.04768888756464884,
                                  0.029143209067285403, 0.015814144455116086,
                                  0.0075476598535781925, 0.00313088112444726,
                                  0.0011116896746226068, 0.00033114160520675284,
                                  8.048580682107342e-05, 1.5330629870691226e-05,
                                  2.146288181847922e-06, 1.9639238268975845e-07,
                                  8.812478746733632e-09, 0.0, 0.0, 0.0, 0.0,
                                  0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.8462531089715948,
                                  0.06318777602315973, 0.04212518401543974,
                                  0.025144489683634585, 0.013334199074654718,
                                  0.006222626234838935, 0.002525123689499864,
                                  0.0008775252537979172, 0.0002559448656910268,
                                  6.0939253735958765e-05,
                                  1.1375327364060439e-05,
                                  1.5613194420671661e-06, 1.401184115401577e-07,
                                  6.168735078304621e-09, 0.0, 0.0, 0.0, 0.0,
                                  0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.8652094417785428,
                                  0.0568689984208437, 0.037030975715898196,
                                  0.02160140250094056, 0.011200727222710039,
                                  0.005113375471237247, 0.002030844158789291,
                                  0.0006910511373657835, 0.000197443182104462,
                                  4.607007582446698e-05, 8.431124987495764e-06,
                                  1.1349591328979614e-06, 9.993350857939731e-08,
                                  4.3181145326087744e-09, 0.0, 0.0, 0.0, 0.0,
                                  0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.8822701413047959,
                                  0.05091759160936005, 0.03240210375141095,
                                  0.018481199917471325, 0.009374521697268268,
                                  0.004188616077502871, 0.0016289062523622277,
                                  0.0005429687507872982, 0.0001520312502205634,
                                  3.4778390573309004e-05, 6.242275231160832e-06,
                                  8.244514455579832e-07, 7.124889034315629e-08,
                                  3.022680217235063e-09, 0.0, 0.0, 0.0, 0.0,
                                  0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.8975454187876039,
                                  0.04536294525197537, 0.028225832601229017,
                                  0.015749196451410374, 0.007818750011338693,
                                  0.0034207031299606783, 0.0013031250018897822,
                                  0.00042568750061722227,
                                  0.00011685539232642039, 2.621755597065345e-05,
                                  4.616928095502182e-06, 5.984906790157396e-07,
                                  5.078102727207323e-08, 2.115876140962314e-09,
                                  0.0, 0.0, 0.0, 0.0, 0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.9111543023631965,
                                  0.04022181145675141, 0.024482841756283458,
                                  0.013370062519388881, 0.006499335946925311,
                                  0.0027854296915393872, 0.0010398937515080364,
                                  0.0003330378681299928, 8.96640414196348e-05,
                                  1.9737367608074763e-05, 3.411396870545147e-06,
                                  4.341777835037419e-07, 3.6181481921637726e-08,
                                  1.4811133430825407e-09, 0.0, 0.0, 0.0, 0.0,
                                  0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.9232208458002219,
                                  0.035500120546611, 0.02114900798521513,
                                  0.011308844547649799, 0.005385164070309534,
                                  0.002261768909530004, 0.0008278369864945789,
                                  0.0002600257201169631, 6.868603927612238e-05,
                                  1.4839576386815878e-05,
                                  2.5182311443883165e-06,
                                  3.1477889306241735e-07, 2.577137137027563e-08,
                                  1.0367793290555483e-09, 0.0, 0.0, 0.0, 0.0,
                                  0.0],
                                 [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
                                  0.0, 0.0, 0.0, 0.0, 0.0, 0.9338708819642052,
                                  0.031194786778192207, 0.018196958953945574,
                                  0.009531740404447708, 0.0044481455220757304,
                                  0.0018315893326192878, 0.0006574936065812942,
                                  0.0002026238158647775, 5.253210040934153e-05,
                                  1.1143172814032098e-05,
                                  1.8571954689683423e-06, 2.280766365769793e-07,
                                  1.8350993724602915e-08, 7.257455747478048e-10,
                                  0.0, 0.0, 0.0, 0.0, 0.0],
                                 ])

    for i in range(len(delta_vals)):
        deltas = delta_vals[i]
        validation_deltas = validation_array[i]

        np.testing.assert_allclose(deltas, validation_deltas, atol=1e-08,
                                   err_msg="mismatch on timestep {}".format(i))